// C Source File
// Created 09.01.2004; 16:00:46

#include <default.h>
#define UNOFFICIAL_OS_SUPPORT

#include <tigcclib.h>
//#include <extgraph.h>
#define OSdequeue _rom_call(short,(__pushort,void*),3AA)

//****************************************************************************

#ifndef __GRAY3P
#include "gray3P.h"
#endif

//****************************************************************************

#define MAX_X LCD_WIDTH
#define MAX_Y LCD_HEIGHT

#define PI2 (6.28) 
#define PIH (1.57) 

#define PI_K 314 
#define PI2_K 628
#define PIH_K 157
#define PI12_K 26

#define MAP_SIZEH 125
#define MAP_SIZE 250
#define MAP_SIZE1 249
#define MAP_SIZE100 25000
#define MAP_SIZE2 62500

#define OBJ_SIZEH 15
#define OBJ_SIZE 30
#define OBJ_SIZE1 29
#define OBJ_SIZE2 900

#define RAY_COUNT 12800
// RAY_COUNT = 160 *80

const unsigned char bit_table[8]={0x80,0x40,0x20,0x10,0x8,0x4,0x2,0x1};

//****************************************************************************

unsigned short i, j, k, m, n, u, v;
short					 s, is, js, ks, x, y, z, xs, ys, zs, xo, yo, zo;
short					 cx, cy, cxo, cyo, cx_map, cy_map, cx_map_undo, cy_map_undo;
short					 menu, quadrant, gr_layer, layer;
long					 l, w, seed, speed;
float					 f;
unsigned short ch, pos;
char					 color, flag, blink;
unsigned char  b, bo, txt[80], roughness, cursor[16], obj_name[9];
unsigned char  *map_data_p, *map_txtdata_p;
unsigned char  *obj_data_p, *obj_txtdata_p, *obj_data_buf_p, *obj_txtdata_buf_p;
unsigned char  *lightp_p, *mediump_p, *darkp_p;
unsigned char  *ptr;
SCR_RECT			 full_screen = {{0, 0, 159, 99}};
BOOL					 q_7or8grays, q_isometric, q_already_shaded, q_line;
BOOL					 q_endline, q_obj_zoom, q_quit;

//****************************************************************************
//****************************************************************************
//****************************************************************************

void error (short err)
{
	GKeyFlush();
  if (Gray3PCheckRunning()) Gray3POff ();
  clrscr();
 	FontSetSys (F_6x8);
	if (err == 1)
	{ sprintf (txt, "There isn't enough"); DrawStr (0, 0 *9, txt, A_NORMAL);
		sprintf (txt, "free RAM!"); DrawStr (0, 1 *9, txt, A_NORMAL);
		sprintf (txt, "Please archive all"); DrawStr (0, 2 *9, txt, A_NORMAL);
		sprintf (txt, "files inclusive maps."); DrawStr (0, 3 *9, txt, A_NORMAL);
		sprintf (txt, "Trying to recover system"); DrawStr (0, 5 *9, txt, A_NORMAL);
		sprintf (txt, "when ready... [Key]"); DrawStr (0, 6 *9, txt, A_NORMAL);
	}
	if (err == 2)
	{ sprintf (txt, "There isn't enough"); DrawStr (0, 0 *9, txt, A_NORMAL);
		sprintf (txt, "free Archive Memory!"); DrawStr (0, 1 *9, txt, A_NORMAL);
		sprintf (txt, "You need the AM for"); DrawStr (0, 2 *9, txt, A_NORMAL);
		sprintf (txt, "saving your maps later."); DrawStr (0, 3 *9, txt, A_NORMAL);
		sprintf (txt, "Trying to recover system"); DrawStr (0, 5 *9, txt, A_NORMAL);
		sprintf (txt, "when ready... [Key]"); DrawStr (0, 6 *9, txt, A_NORMAL);
	}
	if (err == 3)
	{ sprintf (txt, "Couldn't open file"); DrawStr (0, 0 *9, txt, A_NORMAL);
		sprintf (txt, "for writing!"); DrawStr (0, 1 *9, txt, A_NORMAL);
		sprintf (txt, "Maybe bad filename."); DrawStr (0, 2 *9, txt, A_NORMAL);
		sprintf (txt, "Trying to recover system"); DrawStr (0, 4 *9, txt, A_NORMAL);
		sprintf (txt, "when ready... [Key]"); DrawStr (0, 5 *9, txt, A_NORMAL);
	}
 	FontSetSys (F_4x6);
	sprintf (txt, "In case your calc crashes now, you have"); DrawStr (0, 100- 5 *6, txt, A_NORMAL);
	sprintf (txt, "two chances to save the Archive Mem. Try to"); DrawStr (0, 100- 4 *6, txt, A_NORMAL);
	sprintf (txt, "hold [2nd]+[<-]+[->]+[ON], or otherwise hold"); DrawStr (0, 100- 3 *6, txt, A_NORMAL);
	sprintf (txt, "[ON] and remove for a second all batteries."); DrawStr (0, 100- 2 *6, txt, A_NORMAL);
	sprintf (txt, "The calc should only reset the RAM now."); DrawStr (0, 100- 1 *6, txt, A_NORMAL);
	ngetchx();
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void clrscr_gr (short delay)
{
	long l;
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short calibration_scr (void)
{
q_7or8grays =TRUE;
if (!Gray3POn (q_7or8grays)) return (1);
/*
ch = KEY_F1;
while ((ch == KEY_F1) || (ch == KEY_F2))
{
 	clrscr_gr (2);
	for (gr_layer = 0; gr_layer < 3; gr_layer++)
	{	if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
		if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
		if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		
		ScrRectFill (&(SCR_RECT){{0, 0, 159, 8}}, &full_screen , A_REVERSE); 
	 	FontSetSys (F_6x8);
		sprintf (txt, "Display Calibration"); DrawStr (22, 1, txt, A_XOR);
	 	FontSetSys (F_4x6);
		sprintf (txt, "Test & choose the better grayscale mode:"); DrawStr (0, 2 *6 +3, txt, A_REVERSE);
		sprintf (txt, "[F1]   8 grays, better for real calcs (default)"); DrawStr (0, 3 *6 +6, txt, A_REVERSE);
		sprintf (txt, "[F2]   7 grays, use it on VTI emulator"); DrawStr (0, 4 *6 +7, txt, A_REVERSE);
		sprintf (txt, "Set the brightness level to a state so that"); DrawStr (0, 5 *6 +10, txt, A_REVERSE);
		sprintf (txt, "you can still differ the darkest 2 gray levels."); DrawStr (0, 6 *6 +10, txt, A_REVERSE);
	}
	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{1 *20, 80, 2 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=1*20; i<2*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{2 *20, 80, 3 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=2*20; i<3*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{3 *20, 80, 4 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=3*20; i<4*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{3 *20, 80, 4 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=3*20; i<4*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{4 *20, 80, 5 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=4*20; i<5*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{5 *20, 80, 6 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=5*20; i<6*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{5 *20, 80, 6 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=5*20; i<6*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{6 *20, 80, 7 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=6*20; i<7*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{6 *20, 80, 7 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=6*20; i<7*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	ch = ngetchx();
	if (ch == KEY_F1) { q_7or8grays = TRUE; if (Gray3PCheckRunning()) Gray3POff (); Gray3POn (q_7or8grays); }
	if (ch == KEY_F2) { q_7or8grays = FALSE; if (Gray3PCheckRunning()) Gray3POff (); Gray3POn (q_7or8grays); }
	if (ch == KEY_ESC) return (1);
}
*/return (0);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void refer_map_coordinates (short quad)
{
	if (quad == 0)
	{ cx_map = (cx -22) *3; cy_map = (cy -15)	*3; }

	if (quad == 7)
	{ cx_map = cx -1; cy_map = cy -14; }
	if (quad == 4)
	{ cx_map = cx -1; cy_map = cy +70; }
	if (quad == 1)
	{ cx_map = cx -1; cy_map = cy +154; }
	if (quad == 8)
	{ cx_map = cx +123; cy_map = cy -14; }
	if (quad == 5)
	{ cx_map = cx +123; cy_map = cy +70; }
	if (quad == 2)
	{ cx_map = cx +123; cy_map = cy +154; }
	
	if (cx_map < 0) cx_map = 0; 
	if (cx_map > MAP_SIZE1) cx_map = MAP_SIZE1; 
	if (cy_map < 0) cy_map = 0; 
	if (cy_map > MAP_SIZE1) cy_map = MAP_SIZE1; 
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void lake (void)
{
	i = cx_map; j = cy_map;
	z = map_data_p[(i)+(j)*MAP_SIZE];
	l = random(32);
	
	for (j = 0; j < MAP_SIZE; j += 1)
		for (i = 0; i < MAP_SIZE; i += 1)
  	{
  		v = map_data_p[(i)+(j)*MAP_SIZE];
	 		if (v < z)
			{	map_data_p[(i)+(j)*MAP_SIZE] = z;
		  	if (random(3) == 0) l = random(32);
		  	v = (v *64 /z) +l;
		  	if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
				else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
				if (abs (bo - b) <= 1) u = (v +u) /2; else u = v;
		  	if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
				else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));	
			}
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void new_obj (void)
{
	strcpy (obj_name, "noname");
	for (i = 0; i < OBJ_SIZE; i += 1)
 		for (j = 0; j < OBJ_SIZE; j += 1)
  	{
			obj_data_p[(i)+(j)*OBJ_SIZE] = 1;
		}
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 2)
  	{
			if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = 0x11;
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void obj_place (short which)
{
cx_map_undo = cx_map;
cy_map_undo = cy_map;
if (which == 0 || which == 2)
{
	z = 255;
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 1)
  	{
			x = cx_map +i -15;
			if (x < 0)				 x += MAP_SIZE;
			if (x >= MAP_SIZE) x -= MAP_SIZE;
			y = cy_map +j -15;
			if (y < 0)				 y += MAP_SIZE;
			if (y >= MAP_SIZE) y -= MAP_SIZE;
			k = i; l = j;

			v = obj_data_p[(i)+(j)*OBJ_SIZE];
			if (v > 1)
			{	i = x; j = y; 
				v = map_data_p[(i)+(j)*MAP_SIZE];
				if (v < z) z = v;
			}
			i = k; j = l;
		}
}
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 1)
  	{
			x = cx_map +i -15;
			if (x < 0)				 x += MAP_SIZE;
			if (x >= MAP_SIZE) x -= MAP_SIZE;
			y = cy_map +j -15;
			if (y < 0)				 y += MAP_SIZE;
			if (y >= MAP_SIZE) y -= MAP_SIZE;
			k = i; l = j;
			
			i = x; j = y; 
			v = map_data_p[(i)+(j)*MAP_SIZE];
			if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			i = k; j = l; 
			obj_data_buf_p[(i)+(j)*OBJ_SIZE] = v;
			if (i %2 == 0) obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else 					 obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));

			v = obj_data_p[(i)+(j)*OBJ_SIZE];
			
			if (v > 1)
			{	if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
				else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
				
				i = x; j = y; 
				if (which == 0) s = (v -2) *5 +z; else
				if (which == 1) s = (v -2) *5 +map_data_p[(i)+(j)*MAP_SIZE]; else
				if (which == 2 && (v -2) *5 +z >= map_data_p[(i)+(j)*MAP_SIZE]) s = (v -2) *5 +z;
				
				if (which != 2 || (which == 2 && (v -2) *5 +z >= map_data_p[(i)+(j)*MAP_SIZE]))
				{
					if (s > 255) s = 255;
					map_data_p[(i)+(j)*MAP_SIZE] = s;
				
					if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
					else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));	
				}
			}
			i = k; j = l;
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void obj_undo (void)
{
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 1)
  	{
			x = cx_map_undo +i -15;
			if (x < 0)				 x += MAP_SIZE;
			if (x >= MAP_SIZE) x -= MAP_SIZE;
			y = cy_map_undo +j -15;
			if (y < 0)				 y += MAP_SIZE;
			if (y >= MAP_SIZE) y -= MAP_SIZE;
			k = i; l = j;

			v = obj_data_buf_p[(i)+(j)*OBJ_SIZE];
			if (i %2 == 0) u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
			else 					 u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
			i = x; j = y; 
			map_data_p[(i)+(j)*MAP_SIZE] = v;
			if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));	

			i = k; j = l;
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void rotate_obj (void)
{
	for (i = 0; i < OBJ_SIZE; i += 1)
 		for (j = 0; j < OBJ_SIZE; j += 1)
  	{
			b = obj_data_p[(i)+(j)*OBJ_SIZE];
			obj_data_buf_p[(j)+(OBJ_SIZE1-i)*OBJ_SIZE] = b;
				
			if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
			else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
			if (j %2 == 0) obj_txtdata_buf_p[(j/2)+(OBJ_SIZE1-i)*OBJ_SIZEH] = (obj_txtdata_buf_p[(j/2)+(OBJ_SIZE1-i)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else 					 obj_txtdata_buf_p[(j/2)+(OBJ_SIZE1-i)*OBJ_SIZEH] = (obj_txtdata_buf_p[(j/2)+(OBJ_SIZE1-i)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
		}

	for (i = 0; i < OBJ_SIZE; i += 1)
 		for (j = 0; j < OBJ_SIZE; j += 1)
  	{
			obj_data_p[(i)+(j)*OBJ_SIZE] = obj_data_buf_p[(i)+(j)*OBJ_SIZE];
		}
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 2)
  	{
			obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH];
		}
}
				
//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_shadows (void)
{
	for (j = 0; j < MAP_SIZE; j += 1)
	{
		k = 0;
		for (i = 0; i < MAP_SIZE; i += 1)
  	{
			if (i < MAP_SIZE)
				v = map_data_p[(i)+(j)*MAP_SIZE];
			else v = 0;
			if (i > 0)
			{	if ((i-1) %2 == 0) u = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0xf0);
				else 							 u = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			}
			else u = 0;

			if (v > k) k = v;
 			z = k -3; if (z < 0) z = 0;
 			if (v <= z) if (u >= 64) u -= 32;
 			z = k -8; if (z < 0) z = 0;
 		  if (v <= z) if (u >= 64) u -= 32;
		  
			if (i > 0)
			if ((i-1) %2 == 0) map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else 							 map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));	
	
			if (k >= 3) k -= 3;
		}			
	}
	q_already_shaded = TRUE;
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_obj_shadows (void)
{
	for (j = 0; j < OBJ_SIZE; j += 1)
	{
		k = 0;
		for (i = 0; i <= OBJ_SIZE; i += 1)
  	{
			if (i < OBJ_SIZE)
				v = obj_data_buf_p[(i)+(j)*OBJ_SIZE];
			else v = 0;
			if (i > 0)
			{	if ((i-1) %2 == 0) u = (obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] & 0xf0);
				else 							 u = (obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
			}
			else u = 0;
			
			if (v > k) k = v;
			z = k -3; if (z < 0) z = 0;
			if (v <= z) if (u >= 64) u -= 32;
 			z = k -8; if (z < 0) z = 0;
 		  if (v <= z) if (u >= 64) u -= 32;
		  
			if (i > 0)
			if ((i-1) %2 == 0) obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] = (obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else 							 obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] = (obj_txtdata_buf_p[((i-1)/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));	

			if (k >= 1) k -= 1;
		}			
	}
}

//****************************************************************************

void obj_write_to_buf (void)
{
	for (i = 0; i < OBJ_SIZE; i += 1)
 		for (j = 0; j < OBJ_SIZE; j += 1)
  	{
			obj_data_buf_p[(i)+(j)*OBJ_SIZE] = obj_data_p[(i)+(j)*OBJ_SIZE];
		}
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 2)
  	{
			obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] = obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH];
		}
}

//****************************************************************************

void show_obj (short which)
{
if (which == 0) // draws only the selected voxel layer
{
	for (gr_layer = 0; gr_layer < 2; gr_layer++)
	{ if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
		ScrRectFill (&(SCR_RECT){63, 39, 64, 98}, &full_screen, A_NORMAL);
		ScrRectFill (&(SCR_RECT){63, layer *2 +39, 64, layer *2 +40}, &full_screen, A_REVERSE);
		ScrRectFill (&(SCR_RECT){1, 14, 60, 99}, &full_screen, A_NORMAL);
	}
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 	for (i = 0; i < OBJ_SIZE; i += 2)
 	{	m = i *2 +2;
		for (j = 0; j < 42; j += 2)
		{ n = 96 -(j *2);
			DrawPix (m, n, A_REVERSE);
		}
	}
	j = layer;
	for (i = 0; i < OBJ_SIZE; i += 1)
 	{	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 		if (j > 0)
 		{	DrawLine (i*2+1, 98 -((obj_data_p[(i)+(j-1)*OBJ_SIZE] -1) *2), i*2+1, 98, A_REVERSE);
			DrawLine (i*2+2, 98 -((obj_data_p[(i)+(j-1)*OBJ_SIZE] -1) *2), i*2+2, 98, A_REVERSE);
		}
 		DrawLine (i*2+1, 98 -((obj_data_p[(i)+(j)*OBJ_SIZE] -1) *2), i*2+1, 98, A_REVERSE);
		DrawLine (i*2+2, 98 -((obj_data_p[(i)+(j)*OBJ_SIZE] -1) *2), i*2+2, 98, A_REVERSE);
		Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
 		DrawLine (i*2+1, 98 -((obj_data_p[(i)+(j)*OBJ_SIZE] -1) *2), i*2+1, 98, A_REVERSE);
		DrawLine (i*2+2, 98 -((obj_data_p[(i)+(j)*OBJ_SIZE] -1) *2), i*2+2, 98, A_REVERSE);
	}
} else

if (which == 1) // draws only the texture top view
{
	for (gr_layer = 0; gr_layer <3; gr_layer++)
	{ if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
		if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
		ScrRectFill (&(SCR_RECT){67, 39, 126, 98}, &full_screen, A_NORMAL);
	}
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 	for (i = 0; i < OBJ_SIZE; i += 2)
 	{	m = i *2 +68;
		for (j = 0; j < OBJ_SIZE; j += 2)
		{ n = 97 -(j *2);
			DrawPix (m, n, A_REVERSE);
		}
	}
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 1)
  	{	if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
			else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
			is = i*2+67; js = j*2+39;
			if (u >= 32)
			{	if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_REVERSE); }
				if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_NORMAL); }
				else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_REVERSE); }
	   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){is, js, is +1, js +1}, &full_screen, A_REVERSE); }
			}
		}
}

if (which == 2) 
{
	for (j = 0; j < OBJ_SIZE; j += 1)
		for (i = 0; i < OBJ_SIZE; i += 1)
  	{	if (i %2 == 0) u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
			else 					 u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;

 			b = obj_data_buf_p[(i)+(j)*OBJ_SIZE] *5 /4;

			is = i -j +63; js = (i +j) /2 +68;
			if (u >= 32)
			{	if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (is, js -b, is, js, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (is, js -b, is, js, A_REVERSE); }
				if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (is, js -b, is, js, A_NORMAL); }
				else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (is, js -b, is, js, A_REVERSE); }
	   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (is, js -b, is, js, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (is, js -b, is, js, A_REVERSE); }
			}
		}
}

if (which == 3) 
{
	for (j = 7; j < 23; j += 1)
		for (i = 7; i < 23; i += 1)
  	{	if (i %2 == 0) u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
			else 					 u = (obj_txtdata_buf_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;

 			b = obj_data_buf_p[(i)+(j)*OBJ_SIZE] *2;
			if (b > 54) b = 54;
			
			is = ((i -7) -(j -7)) *2 +63; js = ((i -7) +(j -7)) +68;
			if (u >= 32)
			{	if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_REVERSE); }
				if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_NORMAL); }
				else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_REVERSE); }
	   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){is, js -b, is +1, js}, &full_screen, A_REVERSE); }
			}
		}
}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void show_map_sr (void)
{
			if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
	
 			if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_REVERSE); }
			if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_NORMAL); }
			else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_REVERSE); }
   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_REVERSE); }
}

//****************************************************************************

void show_map_lines_sr (short end)
{
			if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
	
			if (end == 0) u = 0;
 			if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
			if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
			else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
}

//****************************************************************************

void show_map (short quad)
{
if (!q_isometric)
{
	if (quad == 0)
	for (j = 0; j < MAP_SIZE1; j += 3)
		for (i = 0; i < MAP_SIZE; i += 3)
  	{	xs = i /3 +22; ys = j /3 +15;
			
			if (i %2 == 0) u = ((map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) +(map_txtdata_p[((i+1)/2)+(j+1)*MAP_SIZEH] & 0xf0)) /2;
			else 					 u = (((map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16) +((map_txtdata_p[((i+1)/2)+(j+1)*MAP_SIZEH] & 0x0f) *16)) /2;
	
 			if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_REVERSE); }
			if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_NORMAL); }
			else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_REVERSE); }
   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_REVERSE); }
		}			

	if (quad == 7)
	for (j = 0; j < 85; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = j +14;
			show_map_sr(); }			
	if (quad == 4)
	for (j = 84; j < 169; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = j -70;
			show_map_sr(); }			
	if (quad == 1)
	for (j = 168; j < MAP_SIZE; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = j -154;
			show_map_sr(); }			

	if (quad == 8)
	for (j = 0; j < 85; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = j +14;
			show_map_sr(); }			
	if (quad == 5)
	for (j = 84; j < 169; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = j -70;
			show_map_sr(); }			
	if (quad == 2)
	for (j = 168; j <	MAP_SIZE; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = j -154;
			show_map_sr(); }
}
else
{
	if (quad == 0)
	for (j = 0; j < MAP_SIZE1; j += 3)
		for (i = 0; i < MAP_SIZE; i += 3)
  	{	xs = i /3 +22;
  	  ys = (j /3) /2 +47 -
  	       (((map_data_p[(i)+(j)*MAP_SIZE] /24) +(map_data_p[(i+1)+(j+1)*MAP_SIZE] /24)) /2);
			
			if (i %2 == 0) u = ((map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) +(map_txtdata_p[((i+1)/2)+(j+1)*MAP_SIZEH] & 0xf0)) /2;
			else 					 u = (((map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16) +((map_txtdata_p[((i+1)/2)+(j+1)*MAP_SIZEH] & 0x0f) *16)) /2;
	
 			if (j == 246) u = 0;
 			if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
			if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
			else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (xs, ys, xs, 98, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawLine (xs, ys, xs, 98, A_REVERSE); }
		}			

	if (quad == 7)
	for (j = 0; j < 85; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = j /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == 84) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	if (quad == 4)
	for (j = 84; j < 169; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = (j -84) /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == 168) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	if (quad == 1)
	for (j = 168; j < MAP_SIZE; j += 1)
		for (i = 0; i < 126; i += 1)
   	{ xs = i +1; ys = (j -168) /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == MAP_SIZE1) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	
	if (quad == 8)
	for (j = 0; j < 85; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = j /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == 84) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	if (quad == 5)
	for (j = 84; j < 169; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = (j -84) /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == 168) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	if (quad == 2)
	for (j = 168; j <	MAP_SIZE; j += 1)
		for (i = 124; i < MAP_SIZE; i += 1)
   	{ xs = i -123; ys = (j -168) /2 +46 -map_data_p[(i)+(j)*MAP_SIZE] /8;
			if (j == MAP_SIZE1) show_map_lines_sr (0); else show_map_lines_sr (1); }			
	}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_base_texture (void)
{
	for (j = 0; j < MAP_SIZE; j += 1)
	{
		for (i = 0; i < MAP_SIZE; i += 1)
  	{
			u = map_data_p[(i)+(j)*MAP_SIZE];
			u = random (170 -(u /3 *2)) +86;
 			 			
			if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (u /16) *16;
			else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] |= (0x0f & (u /16));
		}			
	}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_texture_from_heights (void)
{
	for (j = 0; j < MAP_SIZE; j += 1)
		for (i = 0; i < MAP_SIZE; i += 1)
  	{
			u = map_data_p[(i)+(j)*MAP_SIZE];

			if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (u /16) *16;
			else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] |= (0x0f & (u /16));
		}				
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void smooth_height_map (void)
{
	for (j = 0; j < MAP_SIZE1; j += 1)
		for (i = 0; i < MAP_SIZE1; i += 1)
		{
			u = (map_data_p[(i)+(j)*MAP_SIZE] +map_data_p[(i+1)+(j)*MAP_SIZE] +map_data_p[(i)+(j+1)*MAP_SIZE] +map_data_p[(i+1)+(j+1)*MAP_SIZE]);
			map_data_p[(i)+(j)*MAP_SIZE] = u /4;
		}	
}

//****************************************************************************

void smooth_texture_map (void)
{
	for (j = 0; j < MAP_SIZE1; j += 1)
		for (i = 0; i < MAP_SIZE1; i += 1)
		{
			if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			i++;
			if (i %2 == 0) u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			i--; j++;
			if (i %2 == 0) u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			i++;
			if (i %2 == 0) u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u += (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			i--; j--; u = u /4 +4;
			
			if (i %2 == 0) v = (u /16) *16;
			else 					 
			{
				map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = v;
				map_txtdata_p[(i/2)+(j)*MAP_SIZEH] |= (0x0f & (u /16));
			}
		}	
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void adjust(short xa, short ya, short x, short y, short xb, short yb)
{
  short d;
  float v;

  if (map_data_p[(unsigned)(x)+(y)*MAP_SIZE] != 0) return(0);
  d = abs (xa -xb) + abs (ya -yb);
  v = (map_data_p[(unsigned)(xa)+(ya)*MAP_SIZE] +map_data_p[(unsigned)(xb)+(yb)*MAP_SIZE]) /2 +
      ((random(101) -50) *d *roughness) /100;
  if (v < 1) v = 1;
  if (v > 255) v = 255;
  map_data_p[(unsigned)(x)+(y)*MAP_SIZE] = (unsigned char) trunc (v);
}

//****************************************************************************

void sub_divide (short x1, short y1, short x2, short y2)
{
	short x, y;
  float v;
      
  if ((x2 -x1 < 2) && (y2 -y1 < 2)) return (0);

  x = (x1 +x2) /2;
  y = (y1 +y2) /2;

  adjust (x1,y1,x,y1,x2,y1);
  adjust (x2,y1,x2,y,x2,y2);
  adjust (x1,y2,x,y2,x2,y2);
  adjust (x1,y1,x1,y,x1,y2);

	pos = (unsigned)(x)+(y)*MAP_SIZE;

  if (map_data_p[pos] == 0)
  {
    v = (map_data_p[(unsigned)(x1)+(y1)*MAP_SIZE] +map_data_p[(unsigned)(x2)+(y1)*MAP_SIZE] +
    	   map_data_p[(unsigned)(x2)+(y2)*MAP_SIZE] +map_data_p[(unsigned)(x1)+(y2)*MAP_SIZE]) /4;
    i = map_data_p[pos] = (unsigned char) trunc (v);
	
		xs = x /3 +22; ys = y /3 +15;
		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 		if (i < 128) 		 DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
		Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
		if (i %128 < 64) DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
 		Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
  	if (i %64 < 32)	 DrawPix (xs, ys, A_NORMAL); else DrawPix (xs, ys, A_REVERSE); 
		is++;
	}

	sub_divide(x1,y1,x,y);
 	sub_divide(x,y1,x2,y);
	sub_divide(x,y,x2,y2);
	sub_divide(x1,y,x,y2);
}

//****************************************************************************

void generate_map (long l)
{
	if (l == 0) randomize();
	else srand ((unsigned long) l); //0 to 2147483647
/*	sprintf (txt, "Map-ID: %f ", (float) l);
	DrawStr (0, 7, txt, A_REVERSE);		
*/
	for (i = 0; i < MAP_SIZE; i += 1)
 		for (j = 0; j < MAP_SIZE; j += 1)
  	{
			map_data_p[(i)+(j)*MAP_SIZE] = 0;
		}
 	map_data_p[(0)+(0)*MAP_SIZE] = random(255) +1;
  map_data_p[(MAP_SIZE1)+(0)*MAP_SIZE] = random(255) +1;
  map_data_p[(MAP_SIZE1)+(MAP_SIZE1)*MAP_SIZE] = random(255) +1;
  map_data_p[(0)+(MAP_SIZE1)*MAP_SIZE] = random(255) +1;
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	is = 0;
	sub_divide(0,0,MAP_SIZE1,MAP_SIZE1); // plasma

	for (j = 0; j < MAP_SIZE; j += 1) // makes the map seamless
		for (i = 0; i <= 32; i += 1)
			map_data_p[(MAP_SIZE1-i)+(j)*MAP_SIZE] = (((unsigned) map_data_p[(MAP_SIZE1-i)+(j)*MAP_SIZE] *i) /32) +
																							 (((unsigned) map_data_p[(i)+(j)*MAP_SIZE] 		 *(32 -i)) /32);
	for (j = 0; j <= 32; j += 1)
		for (i = 0; i < MAP_SIZE; i += 1)
			map_data_p[(i)+(MAP_SIZE1-j)*MAP_SIZE] = (((unsigned) map_data_p[(i)+(MAP_SIZE1-j)*MAP_SIZE] *j) /32) +
																							 (((unsigned) map_data_p[(i)+(j)*MAP_SIZE] 		 *(32 -j)) /32);
	generate_texture_from_heights();
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short load_map (short which)
{
FILE *fp;
unsigned short size;
unsigned char btimes;
short result = 0;

FontSetSys (F_4x6);
sprintf (txt, "Loading..."); DrawStr (50, 53, txt, A_REVERSE);
				
if (which <= 1)
{
if (!(fp=fopen("mapt","rb")))
{
	for (i = 0; i < MAP_SIZE; i += 2)
 		for (j = 0; j < MAP_SIZE; j += 1)
  	{
			map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = 0x99;
		}
	result = 1;
}
else
{	#define NAME map_txtdata_p
	size = MAP_SIZE*MAP_SIZEH; fseek(fp, 40, SEEK_SET);
//	fread(NAME, 1, size,fp); //uncompressed
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;
	}
	fclose(fp);
}
q_already_shaded = FALSE;
}

if (which == 0 || which == 2)
{
if (!(fp=fopen("maph","rb")))
{
	for (i = 0; i < MAP_SIZE; i += 1)
 		for (j = 0; j < MAP_SIZE; j += 1)
  	{
			map_data_p[(i)+(j)*MAP_SIZE] = 1;
		}
	result = 1;
}
else
{	#define NAME map_data_p
	size = MAP_SIZE*MAP_SIZE; fseek(fp, 40, SEEK_SET);
//	fread(NAME, 1, size,fp); //uncompressed
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;
	}
	fclose(fp);
}
}

return (result);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short save_map (short which)
{
FILE *fp, *fp2;
unsigned short size, size1, size2, size3;
unsigned char btimes;

if (Gray3PCheckRunning()) Gray3POff();
clrscr (); 

FontSetSys (F_4x6);
sprintf (txt, "Your OS could warn you multiple times now"); DrawStr (-1, 101- 5 *6, txt, A_NORMAL);
sprintf (txt, "because of garbage collect your memory,"); DrawStr (-1, 101- 4 *6, txt, A_NORMAL);
sprintf (txt, "especially if there isn't much memory free."); DrawStr (-1, 101- 3 *6, txt, A_NORMAL);
sprintf (txt, "If so, simply press ENTER to continue."); DrawStr (-1, 101- 2 *6, txt, A_NORMAL);

if (which <= 1)
{
sprintf (txt, "Saving MAPT.VXS..."); DrawStr (-1, 0, txt, A_NORMAL);

#define NAME map_txtdata_p
size = MAP_SIZE*MAP_SIZEH;
size1 = size /2;

if (!(fp=fopen("$wapmem1","wb"))) return (1);
fputs("VOXELSPACE-Engine, (C) Kai Kostack  ",fp);
fputs("RLE",fp);

for (i = 0; i < size; i++)	// compressed
	if (NAME[i] == 0) NAME[i]++;
for (i = 0, k = 0; i < size; i++)	
{
	btimes = 0;
	while ((NAME[i] == NAME[i +1 +btimes]) && (btimes < 255))
		btimes++;
	if (btimes > 2)
	{
		fputc (0 ,fp);
		fputc (btimes ,fp);
		fputc (NAME[i] ,fp);
	}
	else
	for (j = i; j < i +1 +btimes; j++)
		fputc (NAME[j] ,fp);
	i += btimes;

	if (i > size1 && k < 1)
	{	if (fclose(fp) != 0) return (1);
		if (!EM_moveSymToExtMem (SYMSTR("$wapmem1"), HS_NULL)) return (2);
		if (!(fp=fopen("$wapmem2","wb"))) return (1);
		k++;	
	}
}
fputc(0,fp);
fputs("VXS",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
if (fclose(fp) != 0) return (1);
if (!EM_moveSymToExtMem (SYMSTR("$wapmem2"), HS_NULL)) return (2);

if (map_txtdata_p) free (map_txtdata_p);

EM_moveSymFromExtMem (SYMSTR("mapt"), HS_NULL);
if (!(fp=fopen("mapt","wb"))) return (1);

fp2 = fopen ("$wapmem1", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
EM_moveSymFromExtMem (SYMSTR("$wapmem1"), HS_NULL);
unlink ("$wapmem1");
fp2 = fopen ("$wapmem2", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
if (fclose(fp) != 0) return (1);
if (!EM_moveSymToExtMem (SYMSTR("mapt"), HS_NULL)) return (2);
EM_moveSymFromExtMem (SYMSTR("$wapmem2"), HS_NULL);
unlink ("$wapmem2");

if (!(map_txtdata_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZEH))) return (1);
}

if (which == 0)
{
if (map_txtdata_p) free (map_txtdata_p);

FontSetSys (F_4x6);
sprintf (txt, "Saving MAPH.VXS..."); DrawStr (-1, 7, txt, A_NORMAL);

#define NAME map_data_p
size = MAP_SIZE*MAP_SIZE;
size1 = size /4; size2 = size1 *2; size3 = size1 *3;

if (!(fp=fopen("$wapmem1","wb"))) return (1);
fputs("VOXELSPACE-Engine, (C) Kai Kostack  ",fp);
fputs("RLE",fp);

for (i = 0; i < size; i++)	// compressed
	if (NAME[i] == 0) NAME[i]++;
for (i = 0, k = 0; i < size; i++) // compressed
{
	btimes = 0;
	while ((NAME[i] == NAME[i +1 +btimes]) && (btimes < 255))
		btimes++;
	if (btimes > 2)
	{
		fputc (0 ,fp);
		fputc (btimes ,fp);
		fputc (NAME[i] ,fp);
	}
	else
	for (j = i; j < i +1 +btimes; j++)
		fputc (NAME[j] ,fp);
	i += btimes;

	if (i > size1 && k < 1)
	{	if (fclose(fp) != 0) return (1);
		if (!EM_moveSymToExtMem (SYMSTR("$wapmem1"), HS_NULL)) return (2);
		if (!(fp=fopen("$wapmem2","wb"))) return (1);
		k++;	
	}
	if (i > size2 && k < 2)
	{	if (fclose(fp) != 0) return (1);
		if (!EM_moveSymToExtMem (SYMSTR("$wapmem2"), HS_NULL)) return (2);
		if (!(fp=fopen("$wapmem3","wb"))) return (1);
		k++;	
	}
	if (i > size3 && k < 3)
	{	if (fclose(fp) != 0) return (1);
		if (!EM_moveSymToExtMem (SYMSTR("$wapmem3"), HS_NULL)) return (2);
		if (!(fp=fopen("$wapmem4","wb"))) return (1);
		k++;	
	}
}
fputc(0,fp);
fputs("VXS",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
if (fclose(fp) != 0) return (1);
if (!EM_moveSymToExtMem (SYMSTR("$wapmem4"), HS_NULL)) return (2);

if (map_data_p) free (map_data_p);

EM_moveSymFromExtMem (SYMSTR("maph"), HS_NULL);
if (!(fp=fopen("maph","wb"))) return (1);

fp2 = fopen ("$wapmem1", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
EM_moveSymFromExtMem (SYMSTR("$wapmem1"), HS_NULL);
unlink ("$wapmem1");
fp2 = fopen ("$wapmem2", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
EM_moveSymFromExtMem (SYMSTR("$wapmem2"), HS_NULL);
unlink ("$wapmem2");
fp2 = fopen ("$wapmem3", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
EM_moveSymFromExtMem (SYMSTR("$wapmem3"), HS_NULL);
unlink ("$wapmem3");
fp2 = fopen ("$wapmem4", "rb");
while (!feof (fp2)) fputc (fgetc (fp2) ,fp);
if (fclose(fp2) != 0) return (1);
if (fclose(fp) != 0) return (1);
if (!EM_moveSymToExtMem (SYMSTR("maph"), HS_NULL)) return (2);
EM_moveSymFromExtMem (SYMSTR("$wapmem4"), HS_NULL);
unlink ("$wapmem4");
if (!(map_data_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZE))) return (1);
if (!(map_txtdata_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZEH))) return (1);
}

Gray3POn (q_7or8grays);
return (0);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short getfiles(char* search)
{
	int counter, i=0, j=0, k=0, redraw=1;
	char names[50][10]={};	
	SYM_ENTRY *SymPtr;
	FILE *f;
	SCR_RECT rect;

	char temp[10]={}, temp1[10]={};
  char type[5]={};

	FolderGetCur (temp);

	clrscr();
	OSFastArrows = 0;
	OSInitKeyInitDelay (96); OSInitBetweenKeyDelay (24);
		
	temp1[0]=0;
	
	counter = 0;
	SymPtr = SymFindFirst (strcpy (temp1 + 1, temp) + strlen (temp), 1);

	while (SymPtr && counter < 50)
  {
    strcpy (temp, SymPtr->name);

		if ((f = fopen (temp, "rb")))
		{
			fseek (f, -(strlen (search)+2), SEEK_END);
			fread (type, 1, strlen (search), f);
			fclose (f);

    	if (strcmp (search, type)==0)
    	{
//				DrawStr(0, i, temp, 2);
	    	strcpy (names[counter++],temp);
  	  	i += 8;
	    }
		}    
    SymPtr = SymFindNext ();
  }

	if (counter == 0)
	{
		sprintf (txt, "No VXO files found! "); DrawStr (0, 0, txt, A_REVERSE);
		ngetchx();
		return (1);
	}

	i=0; j=0; k=0;
	
	while (ch != KEY_ENTER && ch != KEY_ESC)
	{		
		if (redraw == 1)
		{
			redraw=0;
			clrscr();

			for(i = k; i < counter; i++)
				DrawStr(1, (i -k) *8 +1, names[i], 4);
		}
		rect=(SCR_RECT){{0,(j-k)*8,159,(j-k)*8+7}};
		ScrRectFill( &rect, &(SCR_RECT){{0, 0, 159, 99}},A_XOR);
	
		ch = ngetchx();
		if (ch >= 0x800) ch -= 0x800;

		rect=(SCR_RECT){{0,(j-k)*8,159,(j-k)*8+7}};
		ScrRectFill (&rect, &(SCR_RECT){{0, 0, 159, 99}},A_XOR);

		if (ch == KEY_UP) j--;
		if (ch == KEY_DOWN && j < counter -1) j++;
	
		if ((j - k) < 0)
		{
			if (k > 0) k--;
			else j++;
			redraw = 1;
		}
		if ((j - k) > 11)
		{
			if (k < counter) k++;
			else j--;
			redraw = 1;
		}
	}
	for (i = 0; i <= (signed) strlen (names[j]); i++)
		obj_name[i] = names[j][i];
	
	if (ch == KEY_ENTER) return (0); else return (1); 
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short load_obj (void)
{
FILE *fp;
unsigned short size;
unsigned char btimes;
short result = 0;
				
fp=fopen (obj_name,"rb");
fseek (fp, 16, SEEK_SET);

#define NAME obj_data_p
size = OBJ_SIZE*OBJ_SIZE;
//	fread(NAME, 1, size,fp); //uncompressed
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;
	}

#define NAME obj_txtdata_p
size = OBJ_SIZE*OBJ_SIZEH;
//	fread(NAME, 1, size,fp); //uncompressed
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;
	}

fclose(fp);

return (result);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short save_obj (void)
{
FILE *fp;
unsigned short size;
unsigned char btimes;

if (Gray3PCheckRunning()) Gray3POff();
clrscr (); 

FontSetSys (F_4x6);
sprintf (txt, "Saving *.VXO..."); DrawStr (-1, 0, txt, A_NORMAL);
				
EM_moveSymFromExtMem (SYMSTR(obj_name), HS_NULL);
if (!(fp=fopen (obj_name, "wb"))) return (3);
fputs ("VOXELSPACE-OBJ ",fp);

#define NAME obj_data_p
size = OBJ_SIZE*OBJ_SIZE;
//fwrite(NAME, 1, size, fp); // uncompressed
for (i = 0; i < size; i++)	// compressed
	if (NAME[i] == 0) NAME[i]++;
for (i = 0; i < size; i++)	
{
	btimes = 0;
	while ((NAME[i] == NAME[i +1 +btimes]) && (btimes < 255))
		btimes++;
	if (btimes > 2)
	{
		fputc (0 ,fp);
		fputc (btimes ,fp);
		fputc (NAME[i] ,fp);
	}
	else
	for (j = i; j < i +1 +btimes; j++)
		fputc (NAME[j] ,fp);
	i += btimes;
}

#define NAME obj_txtdata_p
size = OBJ_SIZE*OBJ_SIZEH;
//fwrite(NAME, 1, size, fp); // uncompressed
for (i = 0; i < size; i++)	// compressed
	if (NAME[i] == 0) NAME[i]++;
for (i = 0; i < size; i++)	
{
	btimes = 0;
	while ((NAME[i] == NAME[i +1 +btimes]) && (btimes < 255))
		btimes++;
	if (btimes > 2)
	{
		fputc (0 ,fp);
		fputc (btimes ,fp);
		fputc (NAME[i] ,fp);
	}
	else
	for (j = i; j < i +1 +btimes; j++)
		fputc (NAME[j] ,fp);
	i += btimes;
}

fputc(0,fp);
fputs("VXO",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
if (fclose(fp) != 0) return (1);
if (!EM_moveSymToExtMem (SYMSTR(obj_name), HS_NULL)) return (2);

Gray3POn (q_7or8grays);
return (0);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void draw_menu (void)
{
		FontSetSys (F_4x6);
		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		ScrRectFill (&(SCR_RECT){{0, 0, 126, 12}}, &full_screen, A_REVERSE); 
		ScrRectFill (&(SCR_RECT){{128, 0, 159, 99}}, &full_screen, A_REVERSE); 
		DrawLine (128, 8, 159, 8, A_NORMAL);
		sprintf (txt, "VX.Studio");	DrawStr (128, 1, txt, A_NORMAL);
		sprintf (txt, "VX.Studio");	DrawStr (128, 2, txt, A_NORMAL);
		DrawClipRect (&(WIN_RECT){129, 71, 143, 79}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){145, 71, 159, 79}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){129, 81, 143, 89}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){145, 81, 159, 89}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){129, 91, 143, 99}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){145, 91, 159, 99}, &full_screen, A_NORMAL);
		DrawClipRect (&(WIN_RECT){147, 61, 159, 69}, &full_screen, A_NORMAL);

		sprintf (txt, "ZOOM"); DrawStr (128, 63, txt, A_NORMAL);
		sprintf (txt, "7");	DrawStr (133, 73, txt, A_NORMAL);
		sprintf (txt, "8");	DrawStr (151, 73, txt, A_NORMAL);
		sprintf (txt, "4");	DrawStr (133, 83, txt, A_NORMAL);
		sprintf (txt, "5");	DrawStr (151, 83, txt, A_NORMAL);
		sprintf (txt, "1");	DrawStr (133, 93, txt, A_NORMAL);
		sprintf (txt, "2");	DrawStr (151, 93, txt, A_NORMAL);
		sprintf (txt, "0");	DrawStr (151, 63, txt, A_NORMAL);

		for (gr_layer = 1; gr_layer <3; gr_layer++)
		{ if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	
			DrawLine (128, 9, 159, 9, A_REVERSE);
			sprintf (txt, "VX.Studio");	DrawStr (129, 2, txt, A_REVERSE);
			DrawClipRect (&(WIN_RECT){130, 72, 144, 80}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){146, 72, 160, 80}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){130, 82, 144, 90}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){146, 82, 160, 90}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){130, 92, 144, 100}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){146, 92, 160, 100}, &full_screen, A_REVERSE);
			DrawClipRect (&(WIN_RECT){148, 62, 160, 70}, &full_screen, A_REVERSE);
		}
		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);

//****************************************************************************
		if (menu == 0) // Root menu
		{	sprintf (txt, "F1 File");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 New");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     map");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Editor");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 View");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 1) // File
		{	sprintf (txt, "File");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Save");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Save");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     & exit");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Exit");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 2) // New map
		{	sprintf (txt, "New map");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Rand.");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     map");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Rand.");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     textr.");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Smoothg.");	DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 height");	DrawStr (128, 8 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 textr.");	DrawStr (128, 9 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 3) // Random map
		{	sprintf (txt, "New map");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Random");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "map");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Seed");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Rough-");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     ness");	DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Do it!");	DrawStr (128, 8 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 5) // Editor
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Textr.");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Height");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Both");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Obj.");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 6) // Texture map
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Texture");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "map");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Pencil");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Airbr.");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Undo");	DrawStr (128, 7 *6 -1, txt, A_NORMAL);
		
			DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);

			sprintf (txt, "+,- Color %d", color); DrawStr (62, 7, txt, A_NORMAL);
 			DrawClipRect (&(WIN_RECT){103, 7, 125, 11}, &full_screen, A_NORMAL);

			i = color *32;
			Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 			if (i < 128) 		 ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_NORMAL);
			else 						 ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_REVERSE);
			Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (i %128 < 64) ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_NORMAL);
			else 						 ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_REVERSE);
 			Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
 		 	if (i %64 < 32)	 ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_NORMAL);
 		 	else 						 ScrRectFill (&(SCR_RECT){104, 8, 124, 10}, &full_screen, A_REVERSE);
		}
//****************************************************************************
		if (menu == 7) // Height map
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Height");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "map");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Push");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Pull");	DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Flatn.");	DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Undo");	DrawStr (128, 8 *6 -1, txt, A_NORMAL);
		
			DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
		}
//****************************************************************************
		if (menu == 8) // Both
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Both");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Lake");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Undo");	DrawStr (128, 5 *6 -1, txt, A_NORMAL);
		
			DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
		}
//****************************************************************************
		if (menu == 9) // View
		{	sprintf (txt, "View");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Shade");	DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Isom.");	DrawStr (128, 4 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 10) // Object
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Objects"); DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 New"); DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Load"); DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Edit"); DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Place"); DrawStr (128, 7 *6 -1, txt, A_NORMAL);
		}
//****************************************************************************
		if (menu == 11) // Edit
		{	sprintf (txt, "Edit");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Object"); DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Save"); DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Prev."); DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     & rot."); DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Point"); DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Squar."); DrawStr (128, 8 *6 -1, txt, A_NORMAL);
		
			DrawLine (62, 13, 62, 99, A_REVERSE);
			DrawLine (65, 38, 65, 99, A_REVERSE);
				
			sprintf (txt, "Hold 2ND / SHIFT and use cursor keys"); DrawStr (-1, 0, txt, A_NORMAL);
			sprintf (txt, "to move object / change its height."); DrawStr (-1, 7, txt, A_NORMAL);
			ScrRectFill (&(SCR_RECT){63, 13, 126, 37}, &full_screen, A_REVERSE);
			sprintf (txt, "ENTER Draw"); DrawStr (62, 14, txt, A_NORMAL);
			if (TI89) sprintf (txt, "T,^ Copy layer");
			if (TI92PLUS) sprintf (txt, "TAN,^ Copy layer"); DrawStr (62, 20, txt, A_NORMAL);
			sprintf (txt, "*,/ Switch layer"); DrawStr (62, 26, txt, A_NORMAL);
			sprintf (txt, "+,- Color %d", color); DrawStr (62, 32, txt, A_NORMAL);
 			DrawClipRect (&(WIN_RECT){103, 32, 125, 36}, &full_screen, A_NORMAL);

			i = color *32;
			Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
 			if (i < 128) 		 ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_NORMAL);
			else 						 ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_REVERSE);
			Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (i %128 < 64) ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_NORMAL);
			else 						 ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_REVERSE);
 			Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
 		 	if (i %64 < 32)	 ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_NORMAL);
 		 	else 						 ScrRectFill (&(SCR_RECT){104, 33, 124, 35}, &full_screen, A_REVERSE);
		}
//****************************************************************************
		if (menu == 12) // Preview
		{	sprintf (txt, "Edit");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Object"); DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Preview"); DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Rot.1x"); DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 Rot.2x"); DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Rot.3x"); DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Doubl."); DrawStr (128, 8 *6 -1, txt, A_NORMAL);
			sprintf (txt, "     size"); DrawStr (128, 9 *6 -1, txt, A_NORMAL);

			sprintf (txt, "West"); DrawStr (4, 50, txt, A_REVERSE);
			sprintf (txt, "North"); DrawStr (105, 50, txt, A_REVERSE);
		}
//****************************************************************************
		if (menu == 13) // Place
		{	sprintf (txt, "Editor");	DrawStr (128, 2 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Objects"); DrawStr (128, 3 *6 -1, txt, A_NORMAL);
			sprintf (txt, "Place"); DrawStr (128, 4 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F1 Solid"); DrawStr (128, 5 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F2 S.bool"); DrawStr (128, 6 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F3 Flex"); DrawStr (128, 7 *6 -1, txt, A_NORMAL);
			sprintf (txt, "F4 Undo"); DrawStr (128, 8 *6 -1, txt, A_NORMAL);

			DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
		}

Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************
/*
Base Options
------------
#1	[F1] File
			[F1] Save
			[F2] Save & exit
			[F3] Exit

#2	[F2] New map
#3		[F1] Random map
				[F1] Seed
				[F2] Roughn.
				[F3] Do it!
			[F2] Random texture
			[F3] Smoother height map
			[F3] Smoother texture map

#5	[F3] Editor
#6		[F1] Texture map
				[F1] Pencil
				[F2] Airbrush
				[F3] Undo
#7	 	[F2] Height map
				[F1] Push
				[F2] Pull
				[F3] Flatten square
				[F4] Undo
#8	 	[F3] Both
				[F1] Lake
				[F2] Undo
#10 	[F4] Object
#11			[F1] New
				[F2] Load
#11			[F3] Edit
					[F1] Save
#12				[F2] Preview & rotate
						[F1] Rotate 1x
						[F2] Rotate 2x
						[F3] Rotate 3x
						[F4] Double size
					[F3] Point
					[F4] Square
#13			[F4] Place
					[F1] Solid
					[F2] Solid boolean
					[F3] Flexible
					[F4] Undo

#9	[F4] View
			[F1] Shade
			[F2] Isometric
*/
void check_keys (void)
{
	OSFastArrows = 0;
	OSInitKeyInitDelay (96); OSInitBetweenKeyDelay (4);
//	void *kbq = kbd_queue ();
//	if (!OSdequeue (&ch, kbq))
	if (kbhit()) 
	{
		ch = ngetchx();
		if (ch >= 0x800) ch -= 0x800;

//****************************************************************************
		if (ch == KEY_LEFT || ch == 339 || ch == 342) { if (cx > 1) cx -= 1; if (speed >15000) speed -= 15000; }
	 	if (ch == KEY_RIGHT || ch == 345 || ch == 348) { if (cx < 126) cx += 1; if (speed >15000) speed -= 15000; }
	 	if (ch == KEY_UP || ch == 339 || ch == 345) { if (cy > 14) cy -= 1; if (speed >15000) speed -= 15000; }
	 	if (ch == KEY_DOWN || ch == 342 || ch == 348) { if (cy < 98) cy += 1; if (speed >15000) speed -= 15000; }

		if (ch == '+') if (color < 7) { color++; draw_menu(); } 
		if (ch == '-') if (color > 0) { color--; draw_menu(); }
	
		if (menu != 11 && menu != 12)
		{	if (ch == '1') quadrant = 1; 
			if (ch == '2') quadrant = 2; 
			if (ch == '4') quadrant = 4; 
			if (ch == '5') quadrant = 5; 
			if (ch == '7') quadrant = 7; 
			if (ch == '8') quadrant = 8; 
			if (ch == '0') quadrant = 0; 
			refer_map_coordinates (quadrant); 
			if ((ch == '0') || (ch == '1') || (ch == '2') || (ch == '4') || (ch == '5') || (ch == '7') || (ch == '8'))
			{ clrscr_gr (2); 	draw_menu(); show_map (quadrant); }
		}

		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
//****************************************************************************
		if (menu == 0) // Root menu
		{	if (ch == KEY_F1) { menu = 1; draw_menu(); } // File 
			if (ch == KEY_F2) { menu = 2; draw_menu(); } // New map
			if (ch == KEY_F3) { menu = 5; draw_menu(); } // Editor
			if (ch == KEY_F4) { menu = 9; draw_menu(); } // Preview
			if (ch == KEY_ESC) { menu = 0; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 1) // File
		{	if (ch == KEY_F1) // Save 
			{	s = save_map (0);
				if (s == 1) { error (1); q_quit = TRUE; } else
				if (s == 2) { error (2); q_quit = TRUE; } else
				{ clrscr_gr (2); 
					draw_menu();
					load_map (0);
					load_map (1);
					show_map (quadrant);
				}
			}
			if (ch == KEY_F2) // Save & exit
			{	s = save_map (0);
				if (s == 1) { error (1); q_quit = TRUE; } else
				if (s == 2) { error (2); q_quit = TRUE; } else
				q_quit = TRUE;
			}
			if (ch == KEY_F3) q_quit = TRUE; // Exit
			if (ch == KEY_ESC) { menu = 0; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 2) // New map
		{	if (ch == KEY_F1) { menu = 3; draw_menu(); } // Random map
			if (ch == KEY_F2) // Random texture
			{	clrscr_gr (2); 	draw_menu(); 
				sprintf (txt, "Generating seamless"); DrawStr (-1, 0, txt, A_NORMAL);
				sprintf (txt, "texture map..."); DrawStr (-1, 7, txt, A_NORMAL);
				generate_base_texture();
				quadrant = 0;
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_F3) // Smooth map
			{	sprintf (txt, "Smoothing height map..."); DrawStr (-1, 0, txt, A_NORMAL);
				smooth_height_map(); 
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_F4) // Smooth map
			{	sprintf (txt, "Smoothing texture map..."); DrawStr (-1, 0, txt, A_NORMAL);
				smooth_texture_map();
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_ESC) { menu = 0; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 3) // Random map
		{	if (ch == KEY_F1) // Seed
			{	sprintf (txt, "Enter a seed number [0]:", (float) MAP_SIZE*MAP_SIZE);
				DrawStr (-1, 0, txt, A_NORMAL);
				MoveTo (-1, 7);
				strcpy (txt, "\0");
				gets (txt);
				if (txt[0] != '\0')
				{	l = atol (txt);
					if ((l >= 1) && (l <= 2147483647)) seed = l; //0 to 2147483647
					else
					{ DrawStr (0, 7, "Not in range from 1 to 2147483647! ", A_REVERSE); 
						ngetchx(); }
				}	else seed = 0;
				draw_menu();
			}
			if (ch == KEY_F2) // Roughness
			{	sprintf (txt, "Enter a roughness value [5]:", (float) MAP_SIZE*MAP_SIZE);
				DrawStr (-1, 0, txt, A_NORMAL);
				MoveTo (-1, 7);
				strcpy (txt, "\0");
				gets (txt);
				if (txt[0] != '\0')
				{	l = atol (txt);
					if ((l >= 1) && (l <= 250)) roughness = l;
					else
					{ DrawStr (0, 7, "Not in range from 1 to 250! ", A_REVERSE); 
						ngetchx(); }
				}	else roughness = 5;
				draw_menu();
			}
			if (ch == KEY_F3) // Do it!
			{	clrscr_gr (2); 	draw_menu(); 
				sprintf (txt, "Generating seamless,"); DrawStr (-1, 0, txt, A_NORMAL);
				sprintf (txt, "random height map..."); DrawStr (-1, 7, txt, A_NORMAL);
				if (seed == 0) generate_map (0);
				else generate_map (seed);
				quadrant = 0;
				show_map (quadrant);
				draw_menu();
				sprintf (txt, "Clearing texture map..."); DrawStr (-1, 0, txt, A_NORMAL);
				for (i = 0; i < MAP_SIZE; i += 2)
 					for (j = 0; j < MAP_SIZE; j += 1)
  				{
						map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = 0x99;
					}
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_ESC) { menu = 2; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 5) // Editor
		{	if (ch == KEY_F1) { menu = 6; draw_menu(); } // Texture map
			if (ch == KEY_F2) // Height map
			{	if (q_already_shaded)
				{	clrscr_gr (2); draw_menu();
					load_map (1);
				} 
				else
				{	clrscr_gr (2); draw_menu();
					save_map (1);
				}
				clrscr_gr (2); draw_menu();
				sprintf (txt, "Swapping height map"); DrawStr (-1, 0, txt, A_NORMAL);
				sprintf (txt, "to texture memory..."); DrawStr (-1, 7, txt, A_NORMAL);
				generate_texture_from_heights();
				show_map (quadrant);
				menu = 7; draw_menu(); 
				q_endline = FALSE;
			}
			if (ch == KEY_F3) { menu = 8; draw_menu(); } // Both
			if (ch == KEY_F4) { menu = 10; draw_menu(); } // Objects
			if (ch == KEY_ESC) { menu = 0; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 6) // Texture map
		{	DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
			
			if (ch == KEY_F1) // Pencil
			{	u = color *32 +16;
				i = cx_map; j = cy_map;

				if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
				else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));

				if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (cx, cy, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (cx, cy, A_REVERSE); }
				if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (cx, cy, A_NORMAL); }
				else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (cx, cy, A_REVERSE); }
  	 		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (cx, cy, A_NORMAL); }
  			else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (cx, cy, A_REVERSE); }
			}

			if (ch == KEY_F2) // Airbrush
			{	u = color *32 +16;
				i = cx_map; j = cy_map;
				k = cx; l = cy;
				
				for (n = 0; n < 10; n++)
				{
					xs = random(5)-2; ys = random(5)-2;
					k += xs; l += ys;
					x = i +xs;
					if (x < 0)				 x += MAP_SIZE;
					if (x >= MAP_SIZE) x -= MAP_SIZE;
					y = j +ys;
					if (y < 0)				 y += MAP_SIZE;
					if (y >= MAP_SIZE) y -= MAP_SIZE;
					i = x; j = y;
							
					if (i %2 == 0) map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
					else 					 map_txtdata_p[(i/2)+(j)*MAP_SIZEH] = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));
	
					if (quadrant != 0 && k > 1 && k < 126 && l > 14 && l < 98)
					{	if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (k, l, A_NORMAL); }
  					else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (k, l, A_REVERSE); }
						if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (k, l, A_NORMAL); }
						else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (k, l, A_REVERSE); }
		  	 		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (k, l, A_NORMAL); }
  					else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (k, l, A_REVERSE); }
					}
				}
			}

			if (ch == KEY_F3) // Undo
			{ clrscr_gr (2); draw_menu();
				load_map (0);	show_map (quadrant);
			}
		
			if (ch == KEY_ESC) { menu = 5; clrscr_gr (2); draw_menu(); show_map (quadrant); }
		} else
//****************************************************************************
		if (menu == 7) // Height map
		{	DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
			
			if (ch == KEY_F1) // Push
			{	sprintf (txt, "Lowering terrain..."); DrawStr (-1, 0, txt, A_NORMAL);
				for (j = 0; j <= 20; j += 1)
				{	f = sin (j *PI /20);
					for (i = 0; i <= 20; i += 1)
			  	{	x = cx_map +i -10;
						if (x < 0)				 x += MAP_SIZE;
						if (x >= MAP_SIZE) x -= MAP_SIZE;
						y = cy_map +j -10;
						if (y < 0)				 y += MAP_SIZE;
						if (y >= MAP_SIZE) y -= MAP_SIZE;
						
						k = x; l = y; 
						map_data_p[(k)+(l)*MAP_SIZE] -= f *sin (i *PI /20) *32;
					}
				}
				generate_texture_from_heights();
				show_map (quadrant); draw_menu();
			}
			
			if (ch == KEY_F2) // Pull
			{	sprintf (txt, "Rising terrain..."); DrawStr (-1, 0, txt, A_NORMAL);
				for (j = 0; j <= 20; j += 1)
				{	f = sin (j *PI /20);
					for (i = 0; i <= 20; i += 1)
			  	{	x = cx_map +i -10;
						if (x < 0)				 x += MAP_SIZE;
						if (x >= MAP_SIZE) x -= MAP_SIZE;
						y = cy_map +j -10;
						if (y < 0)				 y += MAP_SIZE;
						if (y >= MAP_SIZE) y -= MAP_SIZE;
						
						k = x; l = y; 
						map_data_p[(k)+(l)*MAP_SIZE] += f *sin (i *PI /20) *32;
					}
				}
				generate_texture_from_heights();
				show_map (quadrant); draw_menu(); 
			}
		
			if (ch == KEY_F3) // Flatten square
			{	if (q_endline)
				{	//	draw square voxel							
					sprintf (txt, "Modifying height map..."); DrawStr (-1, 0, txt, A_NORMAL);
					z = 255;
					for (j = cyo; j <= cy_map; j += 1)
						for (i = cxo; i <= cx_map; i += 1)
				  	{	v = map_data_p[(i)+(j)*MAP_SIZE];
							if (v < z) z = v;
						}
					for (n = 0; n < (255 -z) /10; n += 1, cx_map++, cy_map++)
						for (ys = cyo -n; ys <= cy_map; ys += 1)
							for (xs = cxo -n; xs <= cx_map; xs += 1)
				  		{
					 			x = xs;
								if (x < 0)				 x += MAP_SIZE;
								if (x >= MAP_SIZE) x -= MAP_SIZE;
								y = ys;
								if (y < 0)				 y += MAP_SIZE;
								if (y >= MAP_SIZE) y -= MAP_SIZE;
								k = x; l = y;
							
								if (n == 0) map_data_p[(k)+(l)*MAP_SIZE] = z;
								else 
								if (map_data_p[(k)+(l)*MAP_SIZE] > z +n *10) map_data_p[(k)+(l)*MAP_SIZE] = z +n *10;
							}
					generate_texture_from_heights();
					show_map (quadrant); draw_menu(); 
					q_endline = FALSE;
				}
				else
				{	cxo = cx_map; cyo = cy_map;
					q_endline = TRUE;	}
			}
			if (ch == KEY_F4) // Undo
			{ clrscr_gr (2); draw_menu();
				load_map (2);	
				clrscr_gr (2); draw_menu();
				sprintf (txt, "Swapping height map"); DrawStr (-1, 0, txt, A_NORMAL);
				sprintf (txt, "to texture memory..."); DrawStr (-1, 7, txt, A_NORMAL);
				generate_texture_from_heights();
				show_map (quadrant); draw_menu(); 
			}
			if (ch == KEY_ESC) // Remove everything from texture memory and reload it
			{	clrscr_gr (2); draw_menu();
				load_map (1);	show_map (quadrant);
				menu = 5; draw_menu();
			}
		} else
//****************************************************************************
		if (menu == 8) // Both
		{	DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
			
			if (ch == KEY_F1) // Lake
			{ sprintf (txt, "Generating water surface..."); DrawStr (-1, 0, txt, A_NORMAL);
				lake();
				show_map (quadrant); draw_menu();
			}
			if (ch == KEY_F2) // Undo
			{ clrscr_gr (2); draw_menu();
				load_map (0);	show_map (quadrant);
			}
			if (ch == KEY_ESC) { menu = 5; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 9) // View
		{	if (ch == KEY_F1) // Shade
			{	if (q_already_shaded)
				{	clrscr_gr (2); draw_menu();
				} 
				else
				{	save_map (1);
					clrscr_gr (2); draw_menu();
					load_map (1);
					sprintf (txt, "Generating shadow map..."); DrawStr (-1, 0, txt, A_NORMAL);
					generate_shadows();
				}
				q_isometric = FALSE;
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_F2) // Isometric
			{	if (q_already_shaded)
				{	clrscr_gr (2); draw_menu();
					sprintf (txt, "Generating isometric preview..."); DrawStr (-1, 0, txt, A_NORMAL);
				} 
				else
				{	save_map (1);
					clrscr_gr (2); draw_menu();
					load_map (1);
					sprintf (txt, "Generating shadow map and"); DrawStr (-1, 0, txt, A_NORMAL);
					sprintf (txt, "isometric preview..."); DrawStr (-1, 7, txt, A_NORMAL);
					generate_shadows();
				}
				q_isometric = TRUE;
				show_map (quadrant);
				draw_menu();
			}
			if (ch == KEY_ESC) // Remove everything from texture memory and reload it
			{ 
				clrscr_gr (2); draw_menu();
				if (q_already_shaded) load_map (1);
				q_isometric = FALSE;
				show_map (quadrant);
				menu = 0; draw_menu();
			}
		} else
//****************************************************************************
		if (menu == 10) // Object
		{	if (ch == KEY_F1) {	menu = 11; new_obj(); clrscr_gr (2); draw_menu(); show_obj (0); show_obj (1); q_endline = FALSE; } // New
			if (ch == KEY_F2) // Load
			{ if (Gray3PCheckRunning()) Gray3POff();
				if (getfiles ("VXO") == 0) load_obj(); else ch = 0;
				Gray3POn (q_7or8grays); clrscr_gr (2);
				draw_menu(); show_map (quadrant); }
			if (ch == KEY_F3) {	menu = 11; clrscr_gr (2); draw_menu(); show_obj (0); show_obj (1); q_endline = FALSE; } // Edit
			if (ch == KEY_F4) { menu = 13; draw_menu(); } // Place
			if (ch == KEY_ESC) { menu = 5; draw_menu(); }
		} else
//****************************************************************************
		if (menu == 11) // Editor
		{	if (ch == KEY_F1) // Save
			{	ScrRectFill (&(SCR_RECT){{0, 0, 126, 12}}, &full_screen, A_REVERSE); 
				sprintf (txt, "Enter new filename or press ENTER:", (float) MAP_SIZE*MAP_SIZE);
				DrawStr (-1, 0, txt, A_NORMAL);
				MoveTo (-1, 7);
				strcpy (txt, "\0");
				gets (txt);
				if (txt[0] != '\0')
				{	
					if (strlen(txt) <= 8) strcpy (obj_name, txt);
					else
					{ DrawStr (0, 7, "8 characters are the maximum! ", A_REVERSE); 
						ngetchx(); draw_menu(); goto jump1; }
				}
				s = save_obj();
				if (s == 1) { error (1); q_quit = TRUE; } else
				if (s == 2) { error (2); q_quit = TRUE; } else
				if (s == 3) { error (3); q_quit = TRUE; } else
				{ clrscr_gr (2); 
					draw_menu();
					show_obj (0);	show_obj (1);
				}
				jump1:
			}
			if (ch == KEY_F2) // Preview & rotate
			{ menu = 12;
				clrscr_gr (2); draw_menu();
				sprintf (txt, "Generating isometric preview..."); DrawStr (-1, 0, txt, A_NORMAL);
				obj_write_to_buf(); generate_obj_shadows();	
				show_obj (2); q_obj_zoom = FALSE;
				draw_menu();
			}
			if (ch == KEY_F3) { q_line = FALSE; q_endline = FALSE; } // Point
			if (ch == KEY_F4) { q_line = TRUE; q_endline = FALSE; } // Square
			if (ch == KEY_ESC) { menu = 10; clrscr_gr (2); draw_menu(); show_map (quadrant); }

			if (ch == KEY_ENTER)
			{	if (cx < 61) // voxel side
					if (q_line)
					{	if (q_endline && cxo < 61)
						{	//	draw square voxel							
							for (x = cxo; x <= cx; x += 2)
							{	i = (x -1) /2; j = layer;
								u = (101 -cyo) /2;
								obj_data_p[(i)+(j)*OBJ_SIZE] = u;
								if (u > 1) u = u *5 +40; // because 34 is max voxel height
								if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
								else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
							}	
							q_endline = FALSE;
							show_obj (0);	show_obj (1);
						}
						else
						{	cxo = cx; cyo = cy;
							q_endline = TRUE;	}
					}
					else
					{	//	draw single voxel							
						i = (cx -1) /2; j = layer;
						u = (101 -cy) /2;
						obj_data_p[(i)+(j)*OBJ_SIZE] = u;
						if (u > 1) u = u *5 +40; // because 34 is max voxel height
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
						show_obj (0);	show_obj (1);
					}
				if (cx > 66 && cy > 38) // voxel side
					if (q_line)
					{	if (q_endline && cxo > 66 && cyo > 38)
						{ // draw square color			
						  for (y = cyo; y <= cy; y += 2)
							  for (x = cxo; x <= cx; x += 2)
							  {	i = (x -67) /2; j = (y -39) /2;
									if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
									else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
									if (color == 0) { obj_data_p[(i)+(j)*OBJ_SIZE] = 1; u = 0; }
									else if (obj_data_p[(i)+(j)*OBJ_SIZE] > 1) u = color *32 +16;
									if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
									else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
							 	}
							q_endline = FALSE;
							show_obj (0);	show_obj (1);
						}
						else
						{	cxo = cx; cyo = cy;
							q_endline = TRUE;	}
					}
					else
					{ //	draw single color							
						i = (cx -67) /2; j = (cy -39) /2;
						if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
						else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
						if (color == 0) { obj_data_p[(i)+(j)*OBJ_SIZE] = 1; u = 0; }
						else if (obj_data_p[(i)+(j)*OBJ_SIZE] > 1) u = color *32 +16;
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
						show_obj (0);	show_obj (1);
					}
			}
			if (ch == '*') if (layer < OBJ_SIZE-1) { layer++; show_obj (0); }
			if (ch == '/') if (layer > 0) { layer--; show_obj (0); }

			if (ch == 94) // copy layer higher
			{ for (i = 0; i < OBJ_SIZE; i++)
				{	j = layer;
					b = obj_data_p[(i)+(j)*OBJ_SIZE];
					if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
					else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
					if (j > 0) j--;
					obj_data_p[(i)+(j)*OBJ_SIZE] = b;
					if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
					else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
				}
				show_obj (0);	show_obj (1);
			}
			if (TI89 && ch == 116 || TI92PLUS && ch == 261) // copy layer lower
			{ for (i = 0; i < OBJ_SIZE; i++)
				{	j = layer;
					b = obj_data_p[(i)+(j)*OBJ_SIZE];
					if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
					else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
					if (j < MAP_SIZE -1) j++;
					obj_data_p[(i)+(j)*OBJ_SIZE] = b;
					if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
					else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));
				}
				show_obj (0);	show_obj (1);
			}

			if (ch == 2386) // left
				for (j = 0 ; j < OBJ_SIZE; j++)
					for (i = 1; i <= OBJ_SIZE; i += 2)
					{	
						if (i < OBJ_SIZE)
						{	b = obj_data_p[(i)+(j)*OBJ_SIZE];
							if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
							else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
						}
						else { b = 1; u = 1; }
						i--;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));	
					}
			if (ch == 2392) // right
				for (j = 0 ; j < OBJ_SIZE; j++)
					for (i = OBJ_SIZE; i >= 1; i -= 2)
					{	
						if (i > 1)
						{	i -= 2;
							b = obj_data_p[(i)+(j)*OBJ_SIZE];
							if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
							else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
						}
						else { i -= 2; b = 1; u = 1; }
						i++;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));	
						i += 2;
					}
			if (ch == 2385) // up
				for (i = 0 ; i < OBJ_SIZE; i++)
					for (j = 1; j <= OBJ_SIZE; j += 2)
					{	
						if (j < OBJ_SIZE)
						{	b = obj_data_p[(i)+(j)*OBJ_SIZE];
							if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
							else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
						}
						else { b = 1; u = 1; }
						j--;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));	
					}
			if (ch == 2388) // down
				for (i = 0 ; i < OBJ_SIZE; i++)
					for (j = OBJ_SIZE; j >= 1; j -= 2)
					{	
						if (j > 1)
						{	j -= 2;
							b = obj_data_p[(i)+(j)*OBJ_SIZE];
							if (i %2 == 0) u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0);
							else 					 u = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) *16;
						}
						else { j -= 2; b = 1; u = 1; }
						j++;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
						if (i %2 == 0) obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
						else 					 obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] = (obj_txtdata_p[(i/2)+(j)*OBJ_SIZEH] & 0xf0) | (0x0f & (u /16));	
						j += 2;
					}
			if (ch == 6481) // higher
				for (i = 0; i < OBJ_SIZE; i++)
					for (j = 0; j < OBJ_SIZE; j++)
					{	
						s = obj_data_p[(i)+(j)*OBJ_SIZE] +1;
						if (s > 43) b = 43; else
						if (s <= 2) b = s -1; else b = s;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
					}
			if (ch == 6484) // lower
				for (i = 0; i < OBJ_SIZE; i++)
					for (j = 0; j < OBJ_SIZE; j++)
					{	
						s = obj_data_p[(i)+(j)*OBJ_SIZE] -1;
						if (s <= 1) b = s +1; else b = s;
						obj_data_p[(i)+(j)*OBJ_SIZE] = b;
					}
			if (ch == 2386 || ch == 2392 || ch == 2385 || ch == 2388 || ch == 6481 || ch == 6484)
			{	show_obj (0);	show_obj (1); }
		} else
//****************************************************************************
		if (menu == 12) // Preview & rotate
		{	if (ch == KEY_F1) { rotate_obj(); generate_obj_shadows();	} // Rotate 1x
			if (ch == KEY_F2) { for (n = 0; n < 2 ; n++) rotate_obj(); generate_obj_shadows(); } // Rotate 2x
			if (ch == KEY_F3) { for (n = 0; n < 3 ; n++) rotate_obj(); generate_obj_shadows(); } // Rotate 3x
			if (ch == KEY_F1 || ch == KEY_F2 || ch == KEY_F3) 
			{	clrscr_gr (2); draw_menu();
				sprintf (txt, "Rotating object..."); DrawStr (-1, 0, txt, A_NORMAL);
				if (!q_obj_zoom) show_obj (2); else show_obj (3);
				draw_menu();
			}
			if (ch == KEY_F4) // Double size
			{	clrscr_gr (2); draw_menu();
				q_obj_zoom = !q_obj_zoom;
				if (!q_obj_zoom) show_obj (2); else show_obj (3);
			}
			if (ch == KEY_ESC) { menu = 11; clrscr_gr (2); draw_menu(); show_obj (0);	show_obj (1); }
		} else
//****************************************************************************
		if (menu == 13) // Place
		{	DrawClipRect (&(WIN_RECT){129, 9 *6 -1, 159, 9 *6 +5}, &full_screen, A_NORMAL);
			sprintf (txt, " %03d %03d ",cx_map, cy_map); DrawStr (129, 9 *6, txt, A_REVERSE);
			
			if (ch == KEY_F1) { obj_place (0); show_map (quadrant); } // Solid
			if (ch == KEY_F2) { obj_place (2); show_map (quadrant); } // Solid boolean
			if (ch == KEY_F3) { obj_place (1); show_map (quadrant); } // Flexible
			if (ch == KEY_F4) { obj_undo(); show_map (quadrant); } // Undo
			if (ch == KEY_ESC) { menu = 10; draw_menu(); }
		}
//****************************************************************************
	}
	else speed = 64000;
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

// Main Function
void _main(void)
{
	clrscr();
	OSInitKeyInitDelay (96); OSInitBetweenKeyDelay (4);
	if (calibration_scr() == 1) goto quit;

  if (!(map_data_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZE)))
  { error (1); goto quit; }
  if (!(map_txtdata_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZEH)))
  { error (1); goto quit; }
  if (!(obj_data_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *OBJ_SIZE*OBJ_SIZE)))
  { error (1); goto quit; }
  if (!(obj_txtdata_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *OBJ_SIZE*OBJ_SIZEH)))
  { error (1); goto quit; }
   if (!(obj_data_buf_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *OBJ_SIZE*OBJ_SIZE)))
  { error (1); goto quit; }
  if (!(obj_txtdata_buf_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *OBJ_SIZE*OBJ_SIZEH)))
  { error (1); goto quit; }

//****************************************************************************
	clrscr_gr (3);
	
	lightp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_LIGHT_PLANE);
	mediump_p = (unsigned char *) Gray3PGetPlane (GRAY3P_MEDIUM_PLANE);
	darkp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_DARK_PLANE);

	q_quit = FALSE;
	q_line = FALSE;
	layer = OBJ_SIZE /2;
	menu = 0;
	quadrant = 0;
	seed = 0;
	roughness = 5;
	color = 0;

	draw_menu();
	sprintf (txt, "VX.Studio v1.4, Voxel Map Editor");	DrawStr (-1, 0, txt, A_NORMAL);
	sprintf (txt, "Copyright (C) 2004,06 by Kai Kostack");	DrawStr (-1, 7, txt, A_NORMAL);
	new_obj();
	if (load_map (0) == 1)
	{
		s = save_map (0);
		if (s == 1) { error (1); goto quit; } else
		if (s == 2) { error (2); goto quit; }
		clrscr_gr (2); 
		draw_menu();
		load_map (0);
	}
	clrscr_gr (2); draw_menu();
	sprintf (txt, "VX.Studio v1.4, Voxel Map Editor");	DrawStr (-1, 0, txt, A_NORMAL);
	sprintf (txt, "Copyright (C) 2004,06 by Kai Kostack");	DrawStr (-1, 7, txt, A_NORMAL);
	show_map (quadrant);

  cx = 63; cy = 56; blink = 0;
	ch = 1;
	while (!q_quit)
	{
		if (blink > 0) blink = 0; else blink = 1;
		for (gr_layer = 0; gr_layer <3; gr_layer++)
		{	if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
			if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	
			cursor[0 +(gr_layer *4)] = GetPix(cx-1, cy);	if (blink == 0) DrawPix (cx-1, cy, A_NORMAL); else DrawPix (cx-1, cy, A_REVERSE);
			cursor[1 +(gr_layer *4)] = GetPix(cx+1, cy);	if (blink == 0) DrawPix (cx+1, cy, A_NORMAL); else DrawPix (cx+1, cy, A_REVERSE);
			cursor[2 +(gr_layer *4)] = GetPix(cx, cy-1);	if (blink == 0) DrawPix (cx, cy-1, A_NORMAL); else DrawPix (cx, cy-1, A_REVERSE);
			cursor[3 +(gr_layer *4)] = GetPix(cx, cy+1);	if (blink == 0) DrawPix (cx, cy+1, A_NORMAL); else DrawPix (cx, cy+1, A_REVERSE);
		}
		
		for (w = 0; w < speed; w++);
		
		for (gr_layer = 0; gr_layer <3; gr_layer++)
		{ if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
			if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
			if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	
			if (cursor[0 +(gr_layer *4)] == 1) DrawPix (cx-1, cy, A_NORMAL); else DrawPix (cx-1, cy, A_REVERSE);
			if (cursor[1 +(gr_layer *4)] == 1) DrawPix (cx+1, cy, A_NORMAL); else DrawPix (cx+1, cy, A_REVERSE);
			if (cursor[2 +(gr_layer *4)] == 1) DrawPix (cx, cy-1, A_NORMAL); else DrawPix (cx, cy-1, A_REVERSE);
			if (cursor[3 +(gr_layer *4)] == 1) DrawPix (cx, cy+1, A_NORMAL); else DrawPix (cx, cy+1, A_REVERSE);
		}

		check_keys();
	}

 	quit:
 	clrscr_gr (1);
  OSFastArrows = 0;
	OSInitKeyInitDelay (336); OSInitBetweenKeyDelay (48);
	if (map_data_p) free (map_data_p);
  if (map_txtdata_p) free (map_txtdata_p);
  if (obj_data_p) free (obj_data_p);
  if (obj_txtdata_p) free (obj_txtdata_p);
  if (obj_data_buf_p) free (obj_data_buf_p);
  if (obj_txtdata_buf_p) free (obj_txtdata_buf_p);
  if (Gray3PCheckRunning()) Gray3POff();
}
